// IEPagerCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "IEPager.h"
#include "IEPagerCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIEPagerCtrl

CIEPagerCtrl::CIEPagerCtrl()
{
	m_bCreated = FALSE;
	bInit = FALSE;
}

CIEPagerCtrl::~CIEPagerCtrl()
{
}


BEGIN_MESSAGE_MAP(CIEPagerCtrl, CToolBar)
	//{{AFX_MSG_MAP(CIEPagerCtrl)
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIEPagerCtrl message handlers


/*
 * Function: SetSize
 * Argumments:
 *		int nCurrentSize - The Current Size of the main window
 * Return:
 *		void
 * Remarks:
 *		Use this funcion to notify the control,
 *		to make itself smaller or larger.
 */
void CIEPagerCtrl::SetSize(int nCurrentSize)
{
	BUTTONSINFO HiddenButtonsInfo;
	if ( m_bCreated )
	{
		int nCount = GetToolBarCtrl ( ).GetButtonCount ( );
		int nSizeOfButton = HIWORD ( GetToolBarCtrl ( ).GetButtonSize ( ) );
		int nToolBarSize = nSizeOfButton*nCount;

 		if ( bInit )
		{
			if ( nCurrentSize < nFirstToolBarSize )
			{
				int y = 0, nFCB = 0;// nFCB = nFirstCoveredButton
				int ras = 0;
									//Now, Chaking the number of the FCB
				for ( int i = 1; i < nAllButtons; i++ )
				{
					y = i*nSizeOfButton;
					ras = nCurrentSize - y;
					if ( y > nCurrentSize )
					{
						nFCB = i;
						int nRemainButtons = nFCB - 1;
						int nSub = nRemainButtons*nSizeOfButton;
						int nRemainSpace = nCurrentSize - nSub;
						if ( nRemainSpace < nSizeOfButton )
							nFCB--;
						nGlFCB = nFCB;
						break;
					}
					else
					{
						if ( ras < nSizeOfButton )
						{
							nFCB = i;
							int nRemainButtons = nFCB - 1;
							int nSub = nRemainButtons*nSizeOfButton;
							int nRemainSpace = nCurrentSize - nSub;
//							if ( nRemainSpace < nSizeOfButton )
								nFCB--;
							nGlFCB = nFCB;
							break;
						}
					}
				}
				//Now, before overwriting the information aobut the hidden buttons, we got 
				//to save the information about the hidden buttons.
				//Now, set the number of the buttons to the count of 
				SetButtons(NULL, nFCB + 1);
				for ( int counter = 0; counter < nFCB; counter++ )
				{
					SetButtonInfo ( counter, FirstButInfo[counter].nID,
						FirstButInfo[counter].nStyle, FirstButInfo[counter].iImage);
				}
				SetButtonInfo ( nFCB, ID_ARROW, TBBS_BUTTON, nAllButtons - 3);
			}
			else
			{
				SetButtons(NULL, nAllButtons);
				for ( int counter = 0; counter < nAllButtons; counter++ )
				{
					SetButtonInfo ( counter, FirstButInfo[counter].nID,
						FirstButInfo[counter].nStyle, FirstButInfo[counter].iImage);
				}
			}
		}
		else
		{
			// The Initialization!!!
			nAllButtons = GetToolBarCtrl ( ).GetButtonCount ( );
			nFirstToolBarSize = (HIWORD ( GetToolBarCtrl ( ).GetButtonSize ( ) ))*nAllButtons;
			for ( int counter = 0; counter < nAllButtons; counter++ )
			{
				GetButtonInfo ( counter, FirstButInfo[counter].nID,
					FirstButInfo[counter].nStyle, FirstButInfo[counter].iImage);
				FirstButInfo[counter].strButtonText = GetButtonText ( counter );
			}
			GetToolBarCtrl ( ).AddBitmap ( 1, IDB_ARROW );
			bInit = TRUE;
		}

	}
	m_bCreated = TRUE;
}

/*
 * Functuon: GetHiddenButtonsInfo
 * Arguments:
 *			BUTTONSINFO butInfo[100] structure, in which to be retrieved the information
 *		about only the hidden buttons.
 * Return:
 *		int, of Number of the buttons
 * Remarks:
 *			Use this function to retrieve the information, such as number of an image,
 *		ID and Style of the hidden buttons in the toolbar.
 */
int CIEPagerCtrl::GetHiddenButtonsInfo(BUTTONSINFO butInfo[100])
{
	CString strTip;
	//Clean the Buffer.
	for ( int i = 0; i < nAllButtons; i++)
	{
		butInfo[i].nID = 0;
		butInfo[i].nStyle = 0;
		butInfo[i].iImage = 0;
		butInfo[i].strButtonText = "";
		butInfo[i].strToolTip = "";
	}
	//now get the information about the hidden buttons, and write it tothe structure.
	for ( int count = nGlFCB, int y = 0; count < nAllButtons; count++, y++ )
	{
		butInfo[y].nID				= FirstButInfo[count].nID;
		butInfo[y].nStyle			= FirstButInfo[count].nStyle;
		butInfo[y].iImage			= FirstButInfo[count].iImage;
		butInfo[y].strButtonText	= FirstButInfo[count].strButtonText;
		strTip.LoadString ( FirstButInfo[count].nID );
		strTip = strTip.Left ( strTip.Find( "\n" ) );
		butInfo[y].strToolTip		= strTip;
	}
	return y;
}

void CIEPagerCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CRect recta;	
	GetToolBarCtrl().GetRect(ID_ARROW , &recta);
	ClientToScreen(&recta);
	POINT pt;
	GetCursorPos(&pt);
	if ( PtInRect(&recta, pt) )
	{
	}

	
	CToolBar::OnLButtonUp(nFlags, point);
}
